;; sawDom/theme.jl
;; Created by Michael Spunt

(require 'make-theme)

(let
    ((patterns-alist
      '(("bar-middle"
         (inactive
          "bar-inactive-middle.png")
         (focused
          "bar-active-middle.png"))
        ("bar-right"
         (inactive
          "bar-inactive-right.png")
         (focused
          "bar-active-right.png"))
        ("bar-left"
         (inactive
          "bar-inactive-left.png")
         (focused
          "bar-active-left.png"))
        ("close"
         (inactive
          "close-inactive.png")
         (focused
          "close-active.png")
         (clicked
          "close-active-clicked.png")
         (inactive-clicked
          "close-inactive-clicked.png"))
        ("minimize"
         (inactive
          "minimize-inactive.png")
         (focused
          "minimize-active.png")
         (clicked
          "minimize-active-clicked.png")
         (inactive-clicked
          "minimize-inactive-clicked.png"))
        ("maximize"
         (inactive
          "maximize-inactive.png")
         (focused
          "maximize-active.png")
         (clicked
          "maximize-active-clicked.png")
         (inactive-clicked
          "minimize-inactive-clicked.png"))
        ("menu"
         (inactive
          "menu-inactive.png")
         (focused
          "menu-active.png")
         (clicked
          "menu-active-clicked.png")
         (inactive-clicked
          "menu-inactive-clicked.png"))
        ("border"
         (inactive
          "border.png")
         (focused
          "border.png"))))

     (frames-alist
      '(("frame"
         ((width . 18)
          (left-edge . -1)
          (top-edge . -20)
          (height . 20)
          (background . "menu")
          (class . menu-button))
         ((right-edge . -1)
          (top-edge . -20)
          (background . "close")
          (height . 20)
          (width . 18)
          (class . close-button))
         ((right-edge . 17)
          (top-edge . -20)
          (background . "maximize")
          (width . 18)
          (height . 20)
          (class . maximize-button))
         ((right-edge . 35)
          (top-edge . -20)
          (height . 20)
          (width . 18)
          (background . "minimize")
          (class . iconify-button))
         ((left-edge . 22)
          (right-edge . 58)
          (font . "-b&h-lucida-bold-r-normal-*-*-140-*-*-p-*-*")
          (y-justify . center)
          (x-justify . center)
          (text . window-name)
          (top-edge . -20)
          (class . title)
          (background . "bar-middle"))
         ((left-edge . -1)
          (top-edge . 0)
          (width . 1)
          (bottom-edge . 0)
          (background . "border")
          (class . left-border))
         ((right-edge . -1)
          (width . 1)
          (top-edge . 0)
          (bottom-edge . 0)
          (background . "border")
          (class . right-border))
         ((height . 1)
          (left-edge . 0)
          (bottom-edge . -1)
          (right-edge . 0)
          (background . "border")
          (class . bottom-border))
         ((left-edge . -1)
          (bottom-edge . -1)
          (width . 1)
          (height . 1)
          (background . "border")
          (class . bottom-left-corner))
         ((right-edge . -1)
          (bottom-edge . -1)
          (width . 1)
          (height . 1)
          (background . "border")
          (class . bottom-right-corner))
         ((height . 20)
          (top-edge . -20)
          (width . 5)
          (left-edge . 17)
          (background . "bar-left")
          (class . title))
         ((right-edge . 53)
          (top-edge . -20)
          (width . 5)
          (height . 20)
          (background . "bar-right")
          (class . title)))

        ("nil")

        ("shaped-transient"
         ((left-edge . -1)
          (width . 5)
          (top-edge . -20)
          (background . "bar-left")
          (height . 20)
          (class . title))
         ((right-edge . 4)
          (left-edge . 4)
          (font . "-b&h-lucida-bold-r-normal-*-*-140-*-*-p-*-*")
          (text . window-name)
          (y-justify . center)
          (x-justify . center)
          (top-edge . -20)
          (background . "bar-middle")
          (height . 20)
          (class . title))
         ((right-edge . -1)
          (top-edge . -20)
          (background . "bar-right")
          (width . 5)
          (height . 20)
          (class . title)))

        ("transient"
         ((left-edge . 4)
          (font . "-b&h-lucida-bold-r-normal-*-*-140-*-*-p-*-*")
          (right-edge . 4)
          (y-justify . center)
          (x-justify . center)
          (text . window-name)
          (top-edge . -20)
          (class . title)
          (background . "bar-middle"))
         ((top-edge . 0)
          (bottom-edge . 1)
          (width . 1)
          (left-edge . -1)
          (background . "border")
          (class . left-border))
         ((right-edge . -1)
          (top-edge . 0)
          (bottom-edge . 1)
          (width . 1)
          (background . "border")
          (class . right-border))
         ((right-edge . 0)
          (height . 1)
          (left-edge . 0)
          (bottom-edge . -1)
          (background . "border")
          (class . bottom-border))
         ((left-edge . -1)
          (bottom-edge . 0)
          (width . 1)
          (height . 1)
          (background . "border")
          (class . bottom-left-corner))
         ((right-edge . -1)
          (height . 1)
          (width . 1)
          (bottom-edge . 0)
          (background . "border")
          (class . bottom-right-corner))
         ((top-edge . -20)
          (width . 5)
          (height . 20)
          (left-edge . -1)
          (background . "bar-left")
          (class . title))
         ((right-edge . -1)
          (top-edge . -20)
          (width . 5)
          (height . 20)
          (background . "bar-right")
          (class . title)))

        ("shaped"
         ((left-edge . -1)
          (width . 18)
          (top-edge . -20)
          (background . "menu")
          (height . 20)
          (class . menu-button))
         ((right-edge . -1)
          (top-edge . -20)
          (background . "close")
          (height . 20)
          (width . 18)
          (class . close-button))
         ((right-edge . 17)
          (top-edge . -20)
          (background . "maximize")
          (width . 18)
          (height . 20)
          (class . maximize-button))
         ((right-edge . 35)
          (top-edge . -20)
          (height . 20)
          (width . 18)
          (background . "minimize")
          (class . iconify-button))
         ((left-edge . 22)
          (right-edge . 58)
          (font . "-b&h-lucida-bold-r-normal-*-*-140-*-*-p-*-*")
          (text . window-name)
          (y-justify . center)
          (x-justify . center)
          (top-edge . -20)
          (class . title)
          (background . "bar-middle"))
         ((width . 5)
          (left-edge . 17)
          (top-edge . -20)
          (height . 20)
          (background . "bar-left")
          (class . title))
         ((right-edge . 53)
          (top-edge . -20)
          (width . 5)
          (height . 20)
          (background . "bar-right")
          (class . title)))))

     (mapping-alist
      '((default . "frame")
        (transient . "transient")
        (shaped . "shaped")
        (shaped-transient . "shaped-transient")
        (unframed . "nil")))

     (theme-name 'sawDom))

  (add-frame-style
   theme-name (make-theme patterns-alist frames-alist mapping-alist))
  (when (boundp 'mark-frame-style-editable)
    (mark-frame-style-editable theme-name)))
